<?php
/**
 * clase_zen_singleton.php
 * @author Juan Belon
 * @access public
 * @copyright LGPL, GPL
 * @package zenphp
 * @version 1.0
 * @uses zenphp FrameWork
 * 
 * @magic Clase para crear clases que heredan de ésta y sirve para evitar múltiples instancias. i.e.: una única instancia por cada new()
 */
// +----------------------------------------------------------------------
// | zenphp.es
// +----------------------------------------------------------------------
if (!defined('ZF_SEGURO_ZEN')) exit('Acceso directo no permitido');
//
/**
* Construye la clase en modo singleton
*
* @param str $clase
* @return $clase
*/
function &zen_singleton($clase) {
	static $instancias;
	if (!is_array($instancias)) {
		$instancias = array();
	}

	if (!isset($instancias[$clase]) || !is_object($instancias[$clase]) || !is_a($instancias[$clase],$clase)) {
		$instancias[$clase] =& new $clase;
	}

	return $instancias[$clase];
}

?>
